/******************************************************************************
 Description : This program will read packed BCD from Port C and Display it on
               the screen

 Date        : 10/07/2003
 Version     : 1.0
 Board       : MDE8255LPT-1
 Compiler    : VC++ 6.0
 Website     : www.MicroDigitalEd.com
 Email       : rmckinlay@microdigitaled.com
 OS          : Windows XP
 
 Required files     build type  ver  location
-------------------------------------------------------------
 mdedriverdll.h     released    1.2  in source file directory
 mdedriverdll.lib   released    1.2  in source file directory
 mdedriverdll.dll   released    1.2  in executable directory

*******************************************************************************/
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "mdedriverdll.h"

int main()
  {
  int idriverstatus;                            // setup variables
  unsigned char c_packedbcd;
  unsigned char c_upperbcd;
  unsigned char c_lowerbcd;

  printf("\nOpening Port...");                  // display message

  idriverstatus = MDEOpenLPTPort(0x378);        // open the parallel port
  if(idriverstatus == 0)                        // check the status of driver
    {
    printf("Failed");                           // display message
    return 0;                                   // exit if system driver fails
    }
  else
    {
    printf("Passed");                           // display message
    }

  printf("\nConfig Port....");                  // display message
  MDEConfigPort(0x378, 0x89);                   // send the configuration to the 8255
  printf("done");                               // display message

  do
    {
    c_packedbcd = MDEInPC(0x378);               // read Port C and assign to variable
    
    _asm                                        // use inline assembly
        {
        mov al, c_packedbcd                     // load the register
        mov ah, al                              // copy lower byte to upper byte
        and ax, 0F00Fh                          // mask out 
        mov cl, 4                               // load counter
        shr ah, cl                              // shift register right 4 bits
        or ax, 3030h                            // convert to ascii
        mov c_upperbcd, ah                      // save to variable
        mov c_lowerbcd, al                      // save to variable
        }

    // display the results on the screen
    printf("\nUnpacked BCD : %c%c", c_upperbcd, c_lowerbcd);
    Sleep(1);                                   // system delay for 1 millisecond
    } while(!kbhit());                          // check for keyboard hit

  printf("\nClosing port...");                  // display message
  MDECloseDriver();                             // close the driver
  printf("done\n\n");                           // display message
  return 1;                                     // exit program
  }
  